/*
		public domain uudecode.c
*/

#include <stdio.h>
#ifndef VOS3
#  include <string.h>
#  ifndef MSDOS
#    include <pwd.h> /* for getpwnam */
#  endif
#endif

#ifdef TOOLS
     /* UNIX-like tools1ƂăRpCEzzꍇ͂define
	AʃpbP[W(ektou)ŃRpCEzzꍇdefineȂB
	uMSDOS̏ꍇ͏tools.hincludevƂĂ͂Ȃ */
#  include "tools.h"
#else
#  define s_conv_to_unix_format(s) (s)
#  ifndef MSDOS
#    define fsetbin(f) 0
#  endif
typedef	unsigned char	bool;
#endif

#define	errout(s) fputs((s), stderr)
#define	errcout(c) fputc((c), stderr)

#ifdef VOS3
#  define ERRLVL 8
#else
#  define ERRLVL 1
#endif

char	*cmdname = "uudecode";

static	bool	textmode = 0, tostdout = 0, bs_dollar = 0, ign_garbage = 0;
static	bool	mimcnv_mode = 0;

#ifdef VOS3
 /* VOS3ɂāASf[^Zbg'#'ŎwłBstring.hKv */
static	FILE	*expopen(fn, s, m)
FILE	*((*fn)());
char	*s, *m;
{
	char	*buf, *p, *malloc();
	FILE	*f;

	if(*s != '#') return((*fn)(s, m));
	if(NULL == (buf = malloc(strlen(s) + 2))){
		fprintf(stderr, "Sorry, can't malloc.\n");
		exit(ERRLVL);
	}
	p = buf;

	++s; /* skip '#' */
	*p++ = '\'';
	while(*s && *s != '/') *p++ = *s++;
	*p++ = '\'';
	while(*p++ = *s++);

	f = (*fn)(buf, m);
	free(buf);
	return(f);
}
static	FILE	*orgfopen(s, m) char *s, *m; {return(fopen(s, m));}
static	FILE	*orgpopen(s, m) char *s, *m;
	{extern FILE *popen(); return(popen(s, m));}
#define fopen(s, m) expopen(orgfopen, s, m)
#define popen(s, m) expopen(orgpopen, s, m)

static	FILE	*binreopen(orgf, mode)
FILE	*orgf;
char	mode;
{
	static	char	opt[ ] = "?,BINARY";

	if(isterm(orgf)) return(orgf);
	*opt = mode;
	if((orgf = freopen(NULL, opt, orgf)) == NULL){
		fprintf(stderr, "Can't switch to binary mode.\n");
		exit(ERRLVL);
	}
	return(orgf);
}
#endif /* VOS3 */

static	void	decode(), fnameexp();

static	void	usage()
{
	errout("Usage: "), errout(cmdname), errout(" [-tspim] [infile]\n");
	exit(ERRLVL);
}

static	void	cmd_errout(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	void	nobegin()
{
	cmd_errout("No (or illegal) begin line\n");
	exit(ERRLVL);
}

#define strconsthead(h, s) (!strncmp((h), (s), sizeof(h) - 1))

static	FILE	*fopenchk(fnm, mode)
char	*fnm, *mode;
{
	register FILE	*f;

	if(NULL == (f = fopen(fnm, mode))){
		cmd_errout("Can't open ");
		errout(s_conv_to_unix_format(fnm));
		errcout('\n');
		exit(ERRLVL);
	}
	return(f);
}

#define LBUFSIZ 256
static	char	buf[LBUFSIZ];

main(ac, av)
int	ac;
char	**av;
{
	int	c;
	extern	int	optind, opterr;
	register FILE	*inf, *otf;

#ifdef TOOLS
#  ifdef EXPLICIT_EXPARG /* for tools */
	ac = expand_arg(av[0], get_psp_arg(), &av);
#  endif
#  ifndef MSDOS
	setcmdname(av[0]);
#  endif
	opterr = 0;
#endif

	while(EOF != (c	= getopt(ac, av, "tspim"))){
		switch(c){
		case 't': textmode = 1; break;
		case 'p': tostdout = 1; break;
		case 's': bs_dollar ^= 1; break;
		case 'i': ign_garbage = 1; break;
		case 'm': mimcnv_mode = 1; break;
		default: usage();
		}
	}

	av += optind;
	ac -= optind;
	switch(ac){
	case 1:
		inf = fopenchk(*av, "r");
		break;
	case 0:
		inf = stdin;
		break;
	default:
		usage();
	}

	for(;;){
		if(NULL == fgets(buf, LBUFSIZ, inf)) nobegin();
		if(strconsthead("begin", buf)) break;
	}
	if(tostdout){
		otf = stdout;
	} else {
		char	tmpbuf[LBUFSIZ];
		int	fmode;

		if(sscanf(buf, "%*s %o %s", &fmode, tmpbuf) != 2) nobegin();
		 /* buf̃TCYLBUFSIZtmpbufӂ邱Ƃ͂Ȃ */
		fnameexp(buf, tmpbuf);
		otf = fopenchk(buf, "w");
#ifndef VOS3
		chmod(buf, fmode);
#endif
	}

	if(!textmode) fsetbin(otf);
#ifdef VOS3
	if(!textmode) binreopen(otf, 'w');
	 /* If otf is stdout and not pertitioned, 'a' is preferrable, but we
	    can't examine whether stdout is pertitioned or not... (sigh) */
#endif
	decode(inf, otf);
	return(0);
}

 /* t@C'~'Ŏn܂ĂꍇAWJB
    org̃TCYtmpbufȉ̂*/
static	void	fnameexp(dest, org)
char	*dest, *org;
{
	char	tmpbuf[LBUFSIZ];
#if !defined(MSDOS) && !defined(VOS3)
	struct	passwd	*pw, *getpwnam();
#endif

	if(*org != '~'){
		strcpy(dest, org);
		return;
	}

	if(sscanf(org, "~%[^/]/%s", dest, tmpbuf) != 2){
		cmd_errout("Illegal ~user\n");
		exit(ERRLVL);
	} /* org̃TCYLBUFSIZdesttmpbufӂ邱Ƃ͂Ȃ */
#if !defined(MSDOS) && !defined(VOS3)
	if(NULL == (pw = getpwnam(dest))){
		cmd_errout("No such user as \""), errout(dest), errout("\"\n");
		exit(ERRLVL);
	}
	strcpy(dest, pw -> pw_dir), strcat(dest, "/"), strcat(dest, tmpbuf);
#else /* MSDOS, VOS3 */
	strcpy(dest, tmpbuf);
#endif
}

#ifndef VOS3
#  define ascchar(c) (c)
#else
extern	char	atoektbl[][0x100];
#  define ascchar(c) atoektbl[1][(int)(c) & 0xff]
#endif
#define getbin(p) /* p moves */ \
	(*(p) && *(p) != '\n' ? (ascchar(*(p)++) - 0x20) & 0x3f : 0)
#define endenc(c) ((c) == ' ' || (c) == '`')
#define endenc_n(c) (endenc(c) || (c) == '\n')
 /* ėpOSɂs󔒗̃P[Xl\n܂߂ */

static	mimch_rcnv(c)
int	c;
{
#ifdef VOS3
	c = atoektbl[1][c & 0xff];
#endif
	if(c == 0x2b)		   c = 0x60; else
	if(c == 0x2d || c == 0x2f) c = 0x21; else
	if(0x30 <= c && c <= 0x39) c += 0x22 - 0x30; else
	if(0x41 <= c && c <= 0x5a) c += 0x2c - 0x41; else
	if(0x61 <= c && c <= 0x7a) c += 0x46 - 0x61; else c = 0x7e;
#ifdef VOS3
	c = atoektbl[0][c & 0xff];
#endif
	return c;
}

 /* fR[hʂ0oCgȂ0AłȂΔ0Ԃ */
static	int	decodeline(p, otf)
char	*p;
FILE	*otf;
{
	int	n, i, j;
	register char	cbuf, c1;

	if(0 == (n = getbin(p))) return 0; /* p moves */
	for(i = 0; i < n; i++){
		if(0 == (j = i % 3)) c1 = getbin(p);
		cbuf = c1 << (j*2+2);
		c1 = getbin(p);
		cbuf |= c1 >> (4-j*2);
		putc(cbuf, otf);
	}
	/* *p0ɂȂ炻ȏ|C^i߂AȌ͑Sċ󔒂
	   邩̂悤ɈBɂāAu`vłȂ󔒕g
	   ȃGR[_encodeʂ́AɌ̋󔒂𗎂Ƃꂽ
	   ̂ɂΉł */
	return 1;
}

static	int	peekc(inf)
FILE	*inf;
{
	int	c;

	if(EOF != (c = getc(inf))) ungetc(c, inf);
	return c;
}

static	int	ispreendline(s)
char	*s; /* /^[ `]?[ `]?$/ƂsȂ^ */
{
	char	*p;

	for(p = s; ; p++){
		if(*p == '\n') return 1;
		if(p >= s + 2 || !endenc(*p)) return 0;
	}
}
static	int	isendline(s)
char	*s;
{
	return strconsthead("end", s) && (s[3] == '\n' || !s[3]);
}

static	void	decode(inf, otf)
FILE	*inf, *otf;
{
	char	*p;

	for(;;){
		p = fgets(buf, LBUFSIZ, inf); /* ̍sVOS3 CWarning
		 ôVOS3 C̃oOŁACɂKvȂ */
		if(NULL == p) break;
		if(mimcnv_mode){
			char	*q;

			for(q = p; *q; q++) *q = (char)mimch_rcnv(*q);
		}
		if(bs_dollar){
			char	*q;

			for(q = p; *q; q++){
				switch(*q){
				case '$': *q = '\\'; break;
				case '\\': *q = '$'; break;
				}
			}
		}
		if(ign_garbage){
			int	tmpc;
			char	*q;

			for(q = p;
			    0x20 <= ascchar(*q) && ascchar(*q) <= 0x60; q++);
			if(*q && *q != '\n'){
			illeg_ln:
			 /* ̍suMvŎn܂sɂȂ܂ŖBȂ
			    EOFɂȂAno endlinȅ */
				for(;;){
					if(EOF == (tmpc = peekc(inf)))
						goto noend;
					if('M' == tmpc) break;
					fgets(buf, LBUFSIZ, inf);
				}
				continue;
			}

			if(endenc(*p)){
			 /* Ȃ肱ɂȂ邱Ƃ͂Ȃ͂Ô߁B
			    As̃P[X͏ȂĂ */
				char	tmpbuf[LBUFSIZ];

				if(!ispreendline(p)) goto illeg_ln;

				 /* s"end"łꍇ̍s */
				fgets(tmpbuf, LBUFSIZ, inf);
				if(isendline(tmpbuf)) return;
				goto illeg_ln;
			} else
			if(*p && *p != 'M'){
				 /* sispreendline()𖞂ꍇ
				    ̍s */
				char	tmpbuf[LBUFSIZ];

				if(tmpc = peekc(inf), !endenc_n(tmpc)){
				 /* ̍s͐ȍs̉\ */
					goto illeg_ln;
				}
				fgets(tmpbuf, LBUFSIZ, inf);
				if(!ispreendline(tmpbuf)) goto illeg_ln;

				 /* Ɏ̍s"end" */
				fgets(tmpbuf, LBUFSIZ, inf);
				if(isendline(tmpbuf)){/* ȃf[^Is */
					decodeline(p, otf);
					return;
				} else {
					goto illeg_ln;
				}
			}
		}
		if(!decodeline(p, otf)) break;
	}

	if(p == NULL || NULL == fgets(buf, LBUFSIZ, inf) ||
	    /* "end"ǂ̃`FbN͂Ƃ邢 */
	   !strconsthead("end", buf)){
	noend:
		cmd_errout("No end line\n");
		exit(ERRLVL);
	}
}
